VERSION 5.00
Begin VB.Form frmTerminal 
   BackColor       =   &H00808080&
   ClientHeight    =   5430
   ClientLeft      =   1065
   ClientTop       =   1575
   ClientWidth     =   9375
   ClipControls    =   0   'False
   Icon            =   "Terminal.frx":0000
   LockControls    =   -1  'True
   ScaleHeight     =   5430
   ScaleWidth      =   9375
   Begin VB.Timer tmrPeriodic 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   0
      Top             =   0
   End
   Begin VB.Menu mnuHidden 
      Caption         =   ""
      Visible         =   0   'False
      Begin VB.Menu mnuFocusOnBot 
         Caption         =   "Focus on bot"
         Begin VB.Menu submnuFocusOnBot 
            Caption         =   "Shell View"
            Index           =   0
         End
         Begin VB.Menu submnuFocusOnBot 
            Caption         =   ""
            Index           =   1
         End
      End
      Begin VB.Menu mnuSpawnLocal 
         Caption         =   "Spawn Local"
         Begin VB.Menu submnuSpawnLocal 
            Caption         =   ""
            Index           =   1
         End
      End
      Begin VB.Menu mnuSpawnRemote 
         Caption         =   "Spawn Remote"
         Begin VB.Menu submnuSpawnRemote 
            Caption         =   ""
            Index           =   1
         End
      End
      Begin VB.Menu mnuLoginSound 
         Caption         =   "Login Sound"
         Begin VB.Menu submnuLoginSound 
            Caption         =   ""
            Index           =   1
         End
      End
      Begin VB.Menu mnuCloseAllBots 
         Caption         =   "Close All Bots"
      End
      Begin VB.Menu mnuSeparator4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditSettings 
         Caption         =   "Edit Settings"
      End
      Begin VB.Menu mnuReloadSettingsFile 
         Caption         =   "Reload Settings File"
      End
      Begin VB.Menu mnuSaveSettings 
         Caption         =   "Save Settings and Data"
      End
      Begin VB.Menu mnuOpenAppFolder 
         Caption         =   "Open App Folder"
      End
      Begin VB.Menu mnuSeparator2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPriority 
         Caption         =   "Priority"
         Begin VB.Menu submnuPriority 
            Caption         =   "Normal"
            Index           =   32
         End
         Begin VB.Menu submnuPriority 
            Caption         =   "Idle"
            Index           =   64
         End
         Begin VB.Menu submnuPriority 
            Caption         =   "High"
            Index           =   128
         End
         Begin VB.Menu submnuPriority 
            Caption         =   "Real Time"
            Index           =   256
         End
         Begin VB.Menu mnuSeparator3 
            Caption         =   "-"
         End
         Begin VB.Menu mnuAboutPriority 
            Caption         =   "About Priority..."
         End
      End
      Begin VB.Menu mnuLogTerminal 
         Caption         =   "Log Terminal"
      End
      Begin VB.Menu mnuCopyTerminalToClipboard 
         Caption         =   "Copy Terminal to Clipboard"
      End
      Begin VB.Menu mnuSeparator 
         Caption         =   "-"
      End
      Begin VB.Menu mnuRecycleServer 
         Caption         =   "Recycle Server"
         Begin VB.Menu submnuRecycleServer 
            Caption         =   ""
            Index           =   1
         End
      End
      Begin VB.Menu mnuTerminate 
         Caption         =   "Terminate"
      End
   End
End
Attribute VB_Name = "frmTerminal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Old backcolor (High color): &H00969696&
Private Toggle As Byte 'Use a 1 second timer as a 20 second timer also
'Private MouseDownX As Integer, MouseDownY As Integer 'used for mouse-scrolling the terminal

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Dim I As Integer 'need integer cause a byte cannot be counted down
If KeyCode = 37 Then GoTo changeneg 'left
If KeyCode >= 65 And KeyCode <= 90 Then
 I = KeyCode - 65
 If Shift = 1 Then I = I + 37
 If Shift = 2 Then I = I + 37
 If I < 0 Then I = 0
 If I > MAX_BOTS Then I = MAX_BOTS
 GoTo focuschanged
ElseIf KeyCode = 9 Or KeyCode = 39 Then 'tab,right
 If Shift Then
changeneg:
  I = BotInFocus - 1
  If I < 0 Then I = MAX_BOTS
 Else
  I = BotInFocus + 1
  If I > MAX_BOTS Then I = 0
 End If
focuschanged:
 BotInFocus = I
 UpdateTitleBar BotInFocus
 UpdateTerminal BotInFocus
End If
If KeyCode = 93 Then PopupMenu mnuHidden, 2, 0, 0 'context menu
End Sub

'Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'MouseDownX = x
'MouseDownY = y
'End Sub

'Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'Static lastline As Byte
'If Button = 1 Then
' Dim I As Integer
' 'I = BotInFocus + (Width / (MAX_BOTS * 2)) * ((x - MouseDownX)) / 15
' I = BotInFocus + (x - MouseDownX) / 15
' If I > MAX_BOTS Then I = 0
' If I < 0 Then I = MAX_BOTS
' BotInFocus = CByte(I)
' UpdateTitleBar BotInFocus
' UpdateTerminal BotInFocus
'End If
'End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'If Button = 1 Then Form_KeyDown 9, 0
If Button = 2 And X >= 0 And X <= ScaleWidth And Y >= 0 And Y <= ScaleHeight Then
 PopupMenu mnuHidden, 2, X + 15, Y + 15
End If
End Sub

Private Sub Form_Paint()
UpdateTerminal BotInFocus
End Sub

Private Sub Form_Resize()
UpdateTerminal BotInFocus
End Sub

Private Sub Form_Unload(Cancel As Integer)
SaveINI 'save currently loaded bots first so the next time we start bot we wouldn't have to respawn.

SaveRanks
SaveAliases
SaveScores
SaveMessages
SaveProfiles

UnloadAllBots 0
End Sub

Private Sub mnuAboutPriority_Click()
MsgBox "Changing priority will help reduce lag of the bot significantly.", 64
End Sub

Private Sub mnuCloseAllBots_Click()
If MsgBox("Close all bots ?" & Space(20), 292) = 6 Then UnloadAllBots 1
End Sub

Private Sub mnuCopyTerminalToClipboard_Click()
Screen.MousePointer = 11
Dim S As String, b As Byte, I As Integer
For b = 1 To MAX_BOTS
 For I = MAX_TERMINALLINES To 1 Step -1
  If Terminal(b, I).Msg > "" Then S = S & "(" & b & ") " & Terminal(b, I).Msg & Chr(13) & Chr(10)
 Next
Next
Clipboard.SetText S
Screen.MousePointer = 0
End Sub

Private Sub mnuEditSettings_Click()
On Error Resume Next
Dim L As Long
Do
 L = Shell(TextEditor & " " & GetLongFileName(App.Path, App.Title & ".ini"), 1)
 If L = 0 Then
  Dim OPENFILENAME As comdlg32OPENFILENAMEType, r As Long, S As String
  OPENFILENAME.lStructSize = Len(OPENFILENAME)
  OPENFILENAME.hwndOwner = hwnd
  OPENFILENAME.lpstrTitle = "Text Editor Location"
  OPENFILENAME.lpstrFilter = "Executable Files (*.exe)" & Chr(0) & "*.exe" & Chr(0) & Chr(0) & "COM Files (*.com)" & Chr(0) & "*.com" & Chr(0) & "Batch Files (*.bat)" & Chr(0) & "*.bat" & Chr(0) & "All Files (*.*)" & Chr(0) & "*.*"
  OPENFILENAME.lpstrInitialDir = GetValidDirectoryName(TextEditor, ComDlg32Directory(1))
  OPENFILENAME.nFilterIndex = ComDlg32Extension(1)
  OPENFILENAME.lpstrDefExt = "exe"
  OPENFILENAME.lpstrFile = GetShortFileName2(TextEditor) & Chr(0) & Space(MAX_PATH)
  OPENFILENAME.nMaxFile = MAX_PATH
  OPENFILENAME.Flags = OFN_HIDEREADONLY
  r = GetOpenFileNameA(OPENFILENAME)
  If r Then
   S = GetComDlg32TrimLongFileName(OPENFILENAME.lpstrFile)
   TextEditor = S
   ComDlg32Directory(1) = S
   ComDlg32Extension(1) = OPENFILENAME.nFilterIndex
  End If
 End If
Loop Until r = 0 Or L > 0
End Sub

Private Sub mnuHidden_Click()
On Error Resume Next
mnuCopyTerminalToClipboard = Not LogTerminal
submnuPriority(32).Checked = 0
submnuPriority(64).Checked = 0
submnuPriority(128).Checked = 0
submnuPriority(256).Checked = 0
submnuPriority(GetPriorityClass(GetCurrentProcess)).Checked = 1

mnuLogTerminal.Checked = LogTerminal

Dim b As Byte
submnuFocusOnBot(0).Checked = 0
For b = 1 To MAX_BOTS
 Load submnuFocusOnBot(b)
 Load submnuSpawnLocal(b)
 Load submnuSpawnRemote(b)
 Load submnuLoginSound(b)
 Load submnuRecycleServer(b)
 With Bots(b)
 submnuFocusOnBot(b).Checked = 0
 submnuFocusOnBot(b).Caption = IIf(.Name > "", .Name, "[BLANK NAME]") & IIf(.SpawnConnected, " [online]", IIf(.Spawning Or .AutoConnect, " [connecting]", ""))
 submnuSpawnLocal(b).Checked = .Spawning Or .SpawnConnected Or .AutoConnect
 submnuSpawnLocal(b).Caption = IIf(.Name > "", .Name, "[BLANK NAME]")
 submnuSpawnLocal(b) = .LocalIP = Long2IP(.Sock.sin_addr) And .LocalPort = ntohs(.Sock.sin_port) And (.Spawning Or .SpawnConnected) Or .SpawnConnected = 0 'if this bot is spawned remote, enable
 submnuSpawnRemote(b).Checked = .Spawning Or .SpawnConnected Or .AutoConnect
 submnuSpawnRemote(b).Caption = IIf(.Name > "", .Name, "[BLANK NAME]")
 submnuSpawnRemote(b) = .RemoteIP = Long2IP(.Sock.sin_addr) And .RemotePort = ntohs(.Sock.sin_port) And (.Spawning Or .SpawnConnected) Or .SpawnConnected = 0 'if spawned locally, disable
 submnuLoginSound(b).Caption = IIf(.Name > "", .Name, "[BLANK NAME]") & " - " & GetFormCaptionFileName(.LoginSound)
 submnuRecycleServer(b).Caption = b
 submnuRecycleServer(b) = .SpawnConnected
 End With
Next
submnuFocusOnBot(BotInFocus).Checked = 1
mnuCloseAllBots = (LastConnectingBot > 0)
'mnuRecycleServer = (LastBot > 0) 'if there are any bots connected  this is replaced
End Sub

Private Sub mnuOpenAppFolder_Click()
Shell "explorer " & App.Path, 1
End Sub

Private Sub mnuReLoadSettingsFile_Click()
If MsgBox("Reload all settings ?" & Space(20), 292) = 6 Then
 DefaultINI
 LoadINI
End If
End Sub

Private Sub mnuSaveSettings_Click()
SaveINI

SaveRanks
SaveAliases
SaveScores
SaveMessages
SaveProfiles
End Sub

Private Sub mnuLogTerminal_Click()
LogTerminal = Not LogTerminal
End Sub

Private Sub mnuTerminate_Click()
Unload Me
End Sub

Private Sub submnuLoginSound_Click(Index As Integer)
Dim OPENFILENAME As comdlg32OPENFILENAMEType, r As Long, S As String
OPENFILENAME.lStructSize = Len(OPENFILENAME)
OPENFILENAME.hwndOwner = hwnd
OPENFILENAME.lpstrTitle = "Login Sound - Bot" + CStr(Index)
OPENFILENAME.lpstrFilter = "Audio Files (*.wav)" & Chr(0) & "*.wav" & Chr(0) & "Audio Files (*.snd)" & Chr(0) & "*.snd" & Chr(0) & "Audio Files (*.au)" & Chr(0) & "*.au" & Chr(0) & "Audio Files (*.aif)" & Chr(0) & "*.aif" & Chr(0) & "Audio Files (*.aifc)" & Chr(0) & "*.aifc" & Chr(0) & "Audio Files (*.aiff)" & Chr(0) & "*.aiff" & Chr(0) & "MIDI Files (*.mid)" & Chr(0) & "*.mid" & Chr(0) & "MIDI Files (*.midi)" & Chr(0) & "*.midi" & Chr(0) & "MIDI Files (*.rmi)" & Chr(0) & "*.rmi" & Chr(0) & "Video Files (*.avi)" & Chr(0) & "*.avi" & Chr(0) & "All Files (*.*)" & Chr(0) & "*.*"
OPENFILENAME.lpstrInitialDir = GetValidDirectoryName(Bots(Index).LoginSound, ComDlg32Directory(0))
OPENFILENAME.nFilterIndex = ComDlg32Extension(0)
OPENFILENAME.lpstrDefExt = "wav"
OPENFILENAME.lpstrFile = GetShortFileName2(Bots(Index).LoginSound) & Chr(0) & Space(MAX_PATH)
OPENFILENAME.nMaxFile = MAX_PATH
OPENFILENAME.Flags = OFN_HIDEREADONLY
r = GetOpenFileNameA(OPENFILENAME)
If r Then
 S = GetComDlg32TrimLongFileName(OPENFILENAME.lpstrFile)
 MyPlaySound S, SND_ASYNC
 Bots(Index).LoginSound = S
 ComDlg32Directory(0) = S
 ComDlg32Extension(0) = OPENFILENAME.nFilterIndex
End If
End Sub

Private Sub submnuPriority_Click(Index As Integer)
UpdatePriority Index
End Sub

Private Sub submnuRecycleServer_Click(Index As Integer)
If MsgBox("All the players will be kicked out of the zone." & Chr(13) & "Are you sure you want to recycle ?", 308) = 6 Then PublicMessage CByte(Index), "*recycle", 0
End Sub

'Default interval was 2000
'Private Sub tmrSecures_Timer()
'Resendsecures
'End Sub

'This timer is disabled when all bots are offline or when launched Bot
'Used for auto-connecting and games
Private Sub tmrPeriodic_Timer()
Dim BotIndex As Byte, I As Integer, I2 As Integer, S As String, S2 As String, S3 As String, S4 As String

Toggle = Toggle + 1
If Toggle > 20 Then Toggle = 0

On Error GoTo FlyPaper
For BotIndex = 1 To LastConnectingBot 'loop until LastConnectingBot so we would connect the bot in ConnectBot
 With Bots(BotIndex)
 If Toggle = 10 Then 'Make special non-reliable messages reliable
  If .GotSync = 0 Then SendSync BotIndex 'Resend 05-06 Sync packets. sets to 0 when password is accepted
 ElseIf Toggle = 20 Then
  If .AutoConnect Then ConnectBot BotIndex 'got disconnected by remote server and reconnecting (in Handle_Packet(7)) or trying to connect (auto-reconnect)
  If .GotSync = 0 Then SendSync BotIndex 'Resend 05-06 Sync packets
 End If

 If .SpawnConnected = 0 Then GoTo nextbot 'below is the code only for bots that are connected

 If .KeepAliveCounter >= .KeepAliveTime Then 'Position packets (KeepAlives)
  .KeepAliveCounter = 0
  SendSync BotIndex
 End If
 .KeepAliveCounter = .KeepAliveCounter + 1
' For I = 1 To MAX_QUEUED 'this isn't needed either
'  If .QueuedMessages(I) > "" Then
'   UDPSend BotIndex, .QueuedMessages(I), True
'   .QueuedMessages(I) = ""
'   Bots(BotIndex).UseQueue = 1
'   GoTo NextBot2
'  End If
' Next
' Bots(b).UseQueue = 0
'NextBot2:

 If .PrizeBot Then 'Periodic prizes
  .PrizeCounter = .PrizeCounter + 1
  If .PrizeCounter >= .PrizeTime Then
   .PrizeCounter = 0
   If .PrizeNumber = 0 Then
    PublicMessage BotIndex, "*shipreset", 0
   Else
    PublicMessage BotIndex, "*prize #" + CStr(.PrizeNumber), 0
   End If
  End If
 End If

 If .EvenTeams > 0 Then 'Keep teams even
  I = TeamUnevenCount(BotIndex)
  If I > .EvenTeams Then
   If .EvenCounter = 10 Then
    EvenTeams BotIndex
    PublicMessage BotIndex, "*arena Teams are now even.", 2 * .GameSound
   ElseIf .EvenCounter >= 15 Then
    .EvenCounter = 0
   ElseIf .EvenCounter = 0 Then
    PublicMessage BotIndex, "*arena Teams are uneven. " + CStr(I \ 2) + " player(s) must switch", 1 * .GameSound
   End If
   .EvenCounter = .EvenCounter + 1
  Else
   If .EvenCounter > 10 Then
    .EvenCounter = 0
   ElseIf .EvenCounter > 0 Then
    PublicMessage BotIndex, "*arena Teams are now even.", 2 * .GameSound
    .EvenCounter = 0
   End If
  End If
 End If

 If .Monkey Then 'MonkeyBot that changes settings
  .MonkeyCounter = .MonkeyCounter + 1
  If .MonkeyCounter >= .MonkeyRate Then
   .MonkeyCounter = 0
   MonkeySettings BotIndex
  End If
 End If

 If .ShipResetBot > 1 Then
  .ShipResetCounter = .ShipResetCounter + 1
  If .ShipResetCounter >= .ShipResetBot Then
   .ShipResetCounter = 0
   For I = 0 To .LastUser
    If .Users(I).Name > "" And .Users(I).Ship < 8 Then PrivateMessage BotIndex, I, "*shipreset", 0
   Next
  End If
 End If

 If .Enabled Then 'enabled game bot(s)
  S4 = IIf(IsPublicArena(.Arena), " ", " " + .Arena + " ")
  Select Case .Type
  Case 1 'elim
   Select Case .Status
   Case CHECK
    'Enough players, all on same freq, etc
    If CheckPlayerCount(BotIndex, 2, False) Then
     PublicMessage BotIndex, "*zone Next elimination match is starting. Type ?go" + S4 + "to play", 0
     PublicMessage BotIndex, "*arena Vote: 1-any ship elim, 2-any ship race, 3-wb elim, 4-wb race, 5-jav elim, 6-jav race, 7-team elim, 8-golf", 2 * .GameSound
     .GameCounter = 0
     .Status = VOTE_GAME
    End If
   Case VOTE_GAME
    'Wait for votes on elim type
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 15 Then
     If CheckPlayerCount(BotIndex, 2, False) Then
      .ElimType = AddVote("", 1, 8, .ElimType, 1) 'if haven't voted in HandleGamePacket,Public_Message, get last value (default). clear votes
      Select Case .ElimType
      Case Vanilla: PublicMessage BotIndex, "*arena It is elim. Number of deaths? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case Race: PublicMessage BotIndex, "*arena It is race. Number of kills? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case wbelim: PublicMessage BotIndex, "*arena It is warbird elim. Number of deaths? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case wbrace: PublicMessage BotIndex, "*arena It is warbird race. Number of kills? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case javelim: PublicMessage BotIndex, "*arena It is javelin elim. Number of deaths? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case javrace: PublicMessage BotIndex, "*arena It is javelin race. Number of kills? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case teamelim: PublicMessage BotIndex, "*arena It is team elim. Number of deaths? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      Case GolfElim: PublicMessage BotIndex, "*arena It is golf elim. Maximum number of points? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
      End Select
      .GameCounter = 0
      .Status = VOTE_DEATHS
     Else
      PublicMessage BotIndex, "*arena Not enough players. Elim will start when 2 players enter", 1 * .GameSound
      .GameCounter = 0
      .Status = CHECK
     End If
    End If
   Case VOTE_DEATHS
    'Wait for votes on deaths or wins
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 15 Then
     If CheckPlayerCount(BotIndex, 2, False) Then
      .MaxDeaths = AddVote("", 1, 10, .MaxDeaths, 1) 'if haven't voted in HandleGamePacket,Public_Message, get last value (default). clear votes
      S = IIf(.MaxDeaths = 1, " death", " deaths")
      S2 = IIf(.MaxDeaths = 1, " kill", " kills")
      S3 = IIf(.MaxDeaths = 1, " point", " points")
      Select Case .ElimType
      Case Vanilla: PublicMessage BotIndex, "*arena Elimination to " + CStr(.MaxDeaths) + S + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case Race: PublicMessage BotIndex, "*arena Race to " + CStr(.MaxDeaths) + S2 + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case wbelim: PublicMessage BotIndex, "*arena Warbird Elimination to " + CStr(.MaxDeaths) + S + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case wbrace: PublicMessage BotIndex, "*arena Warbird Race to " + CStr(.MaxDeaths) + S2 + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case javelim: PublicMessage BotIndex, "*arena Javelin Elimination to " + CStr(.MaxDeaths) + S + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case javrace: PublicMessage BotIndex, "*arena Javelin Race to " + CStr(.MaxDeaths) + S2 + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case teamelim: PublicMessage BotIndex, "*arena Team Elimination to " + CStr(.MaxDeaths) + S + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      Case GolfElim: PublicMessage BotIndex, "*arena Golf Elimination up to " + CStr(.MaxDeaths) + S3 + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      End Select
      .GameCounter = 0
      .Status = WAIT_AFTER_RESULTS
     Else
      PublicMessage BotIndex, "*arena Not enough players. Elim will start when 2 players enter", 1 * .GameSound
      .GameCounter = 0
      .Status = CHECK
     End If
    End If
   Case WAIT_AFTER_RESULTS
    'Wait for 10 seconds, then start the elim
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 10 Then
     If CheckPlayerCount(BotIndex, 2, False) Then
      AddAllPlaying BotIndex, False
      PublicMessage BotIndex, "*lock", 0
      PublicMessage BotIndex, "*scorereset", 0
      PublicMessage BotIndex, "*shipreset", 0
      PublicMessage BotIndex, "*arena GO! GO! GO!", 104 * .GameSound
      .GameCounter = 0
      If .ElimType = javelim Or .ElimType = javrace Then
       For I = 0 To .LastUser
        If .Users(I).Name > "" Then
         If .Users(I).Ship <> 1 And .Users(I).Ship < 8 Then
          PrivateMessage BotIndex, I, "*setship 2", 0
         End If
        End If
       Next
       .LockShips = 2
      ElseIf .ElimType = wbelim Or .ElimType = wbrace Then
       For I = 0 To .LastUser
        If .Users(I).Name > "" Then
         If .Users(I).Ship <> 0 And .Users(I).Ship < 8 Then
          PrivateMessage BotIndex, I, "*setship 1", 0
         End If
        End If
       Next
       .LockShips = 1
      ElseIf .ElimType = GolfElim Then
       For I = 0 To .LastUser
        If .Users(I).Name > "" And .Users(I).Ship < 8 Then
         .Users(I).GamePoints = 1
        Else
         .Users(I).GamePoints = 0
        End If
       Next
      End If
      If .ElimType <> teamelim Then
       SeparateTeams BotIndex
      Else
       MergeTeams BotIndex
      End If
      .Status = started
     Else
      PublicMessage BotIndex, "*arena Not enough players. Elim will start when 2 players enter", 1 * .GameSound
      .GameCounter = 0
      .Status = CHECK
     End If
    End If
   Case started
    'Check for GAME OVER
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 20 Then
     .GameCounter = 0
     FindHiders BotIndex, MAX_X \ 10
    End If
    If .ElimType = Vanilla Or .ElimType = wbelim Or .ElimType = javelim Or .ElimType = GolfElim Then
     If .TotalPlaying = 1 Then 'only 1 player is left
      For I = 0 To .LastUser
       If .Users(I).Playing Then
        PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(I).Name, 103 * .GameSound
        Exit For
       End If
      Next
      PublicMessage BotIndex, "*lock", 0
      TeamM BotIndex, "You may enter", 0
      .LockShips = 0
      UpdateRank .Users(I).Name, True, .Users(I).Wins, .Users(I).Losses
      .Status = CHECK
     ElseIf .TotalPlaying = 0 Then 'all quit at the same time
      PublicMessage BotIndex, "*arena GAME OVER. No winner", 103 * .GameSound
      PublicMessage BotIndex, "*lock", 0
      TeamM BotIndex, "You may enter", 0
      .LockShips = 0
      .Status = CHECK
     End If
    ElseIf .ElimType = teamelim Then
     Select Case CheckTeamElimVictory(BotIndex)
     Case 0
      PublicMessage BotIndex, "*arena GAME OVER. Winner: Team 0", 103 * .GameSound
      PublicMessage BotIndex, "*lock", 0
      TeamM BotIndex, "You may enter", 0
      For I = 0 To .LastUser
       If .Users(I).Playing Then UpdateRank .Users(I).Name, True, .Users(I).Wins, .Users(I).Losses
      Next
      .Status = CHECK
     Case 1
      PublicMessage BotIndex, "*arena GAME OVER. Winner: Team 1", 103 * .GameSound
      PublicMessage BotIndex, "*lock", 0
      TeamM BotIndex, "You may enter", 0
      For I = 0 To .LastUser
       If .Users(I).Playing Then UpdateRank .Users(I).Name, True, .Users(I).Wins, .Users(I).Losses
      Next
      .Status = CHECK
     End Select
    End If
   End Select
  Case 2 'zombie
   Select Case .Status
   Case CHECK
    'Enough players?
    If CheckPlayerCount(BotIndex, 3, False) Then
     If CheckPlayerCount(BotIndex, 1, True) Then
      .Status = WAIT
     End If
    End If
   Case WAIT
    'Wait for someone to become a zombie
    If CheckPlayerCount(BotIndex, 1, True) Then
     If CheckPlayerCount(BotIndex, 3, False) Then
      Select Case CInt(Rnd * 3)
      Case 0: PublicMessage BotIndex, "*zone Zombies starting. Type ?go" + S4 + "to play!", 0
      Case 1: PublicMessage BotIndex, "*zone ...and then there are Zombies. Type ?go" + S4 + "to play!", 0
      Case 2: PublicMessage BotIndex, "*zone Straying SubSpacians have awakened the Zombie Horde! Type ?go" + S4 + "to save the human race!", 0
      Case 3: PublicMessage BotIndex, "*zone Hi! I'm a 21-year-old blonde and I LOVE Zombies. Type ?go" + S4 + "to play!", 0
      End Select
      PublicMessage BotIndex, "*arena Get ready; Zombies will start in 20 seconds.", 2 * .GameSound
      .GameCounter = 0
      .Status = PAUSE
     Else
      PublicMessage BotIndex, "*arena Not enough players. Zombies will start when 3 players enter", 1 * .GameSound
      .Status = CHECK
     End If
    Else
     PublicMessage BotIndex, "*arena One player must become a zombie on freq 1", 0
     .Status = CHECK
    End If
   Case PAUSE
    'Wait for 10 seconds if there are enuf players
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 20 Then
     If CheckPlayerCount(BotIndex, 3, False) Then
      If CheckPlayerCount(BotIndex, 1, True) Then
       AddAllPlaying BotIndex, True
       PublicMessage BotIndex, "*arena GO! GO! GO!", 104 * .GameSound
       PublicMessage BotIndex, "*shipreset", 0
       .Status = started
      Else
       PublicMessage BotIndex, "*arena One player must become a zombie on freq 1", 0
       .Status = CHECK
      End If
     Else
      PublicMessage BotIndex, "*arena Not enough players. Zombies will start when 3 players enter", 1 * .GameSound
      .Status = CHECK
     End If
    End If
   Case started
    'Check for GAME OVER
    If .TotalPlaying = 1 Then
     For I = 0 To .LastUser
      If .Users(I).Playing Then PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(I).Name, 103 * .GameSound
      If .Users(I).Name > "" And .Users(I).Freq = 1 And .Users(I).Ship < 8 Then PrivateMessage BotIndex, I, "*setfreq 0", 0
     Next
     .Status = WAIT
    ElseIf .TotalPlaying = 0 Then
     PublicMessage BotIndex, "*arena GAME OVER. No winner", 103 * .GameSound
     For I = 0 To .LastUser
      If .Users(I).Name > "" And .Users(I).Freq = 1 And .Users(I).Ship < 8 Then PrivateMessage BotIndex, I, "*setfreq 0", 0
     Next
     .Status = WAIT
    End If
   End Select
  Case 5 'conquer
   Select Case .Status
   Case CHECK
    'Enough players?
    If CheckPlayerCount(BotIndex, 4, False) Then
     PublicMessage BotIndex, "*zone Conquer starting. Type ?go" + S4 + "to play!", 0
     PublicMessage BotIndex, "*arena Get ready; Conquer will start in 30 seconds", 2 * .GameSound
     .GameCounter = 0
     .Status = WAIT
    End If
   Case WAIT
    'Wait 10 seconds and check if there are enuf ppl again
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 30 Then
     If CheckPlayerCount(BotIndex, 4, False) Then
      SetupConquer BotIndex
      PublicMessage BotIndex, "*arena You have been gifted with the ability to enslave your fellow subspacians.", 0
      PublicMessage BotIndex, "*arena Who will be Supreme Ruler of the Universe?", 0
      PublicMessage BotIndex, "*arena Conquer!", 104 * .GameSound
      PublicMessage BotIndex, "*lock", 0
      PublicMessage BotIndex, "*shipreset", 0
      .Status = started
     Else
      PublicMessage BotIndex, "*arena Not enough players. Conquer will start when 4 players enter", 1 * .GameSound
      .Status = CHECK
     End If
    End If
   End Select
  Case 7 'freeelim
   Select Case .Status
   Case CHECK
    'Enough players, all on same freq, etc
    If CheckPlayerCount(BotIndex, 2, False) Then
     PublicMessage BotIndex, "*zone Next free elimination match is starting. Type ?go" + S4 + "to play", 0
     PublicMessage BotIndex, "*arena Number of deaths? (1-10). Current is " + CStr(.MaxDeaths), 2 * .GameSound
     .GameCounter = 0
     .Status = VOTE_DEATHS
    End If
   Case VOTE_DEATHS
    'Wait for votes on deaths or wins
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 15 Then
     If CheckPlayerCount(BotIndex, 2, False) Then
      .MaxDeaths = AddVote("", 1, 10, .MaxDeaths, 1) 'if haven't voted in HandleGamePacket,Public_Message, get last value (default). clear votes
      PublicMessage BotIndex, "*arena FreeElimination to " + CStr(.MaxDeaths) + IIf(.MaxDeaths = 1, " death", " deaths") + ". Get ready; the game will start in 10 seconds", 2 * .GameSound
      .GameCounter = 0
      .Status = WAIT_AFTER_RESULTS
     Else
      PublicMessage BotIndex, "*arena Not enough players. FreeElim will start when 2 players enter", 1 * .GameSound
      .GameCounter = 0
      .Status = CHECK
     End If
    End If
   Case WAIT_AFTER_RESULTS
    'Wait for 10 seconds, then start the elim
    .GameCounter = .GameCounter + 1
    If .GameCounter >= 10 Then
     If CheckPlayerCount(BotIndex, 2, False) Then
      AddAllPlaying BotIndex, False
      For I = 0 To .LastUser
       .Users(I).Wins = 0
       .Users(I).Losses = 0
      Next
      PublicMessage BotIndex, "*arena GO! GO! GO!", 104 * .GameSound
      .GameCounter = 0
      .Status = started
     Else
      PublicMessage BotIndex, "*arena Not enough players. FreeElim will start when 2 players enter", 1 * .GameSound
      .GameCounter = 0
      .Status = CHECK
     End If
    End If
   Case started
    If .TotalPlaying = 1 Then 'only 1 player is left
     For I = 0 To .LastUser
      If .Users(I).Playing Then
       PublicMessage BotIndex, "*arena GAME OVER. Winner: " + .Users(I).Name, 103 * .GameSound
       UpdateRank .Users(I).Name, True, .Users(I).Wins, .Users(I).Losses
       Exit For
      End If
     Next
     .Status = CHECK
    ElseIf .TotalPlaying = 0 Then
     PublicMessage BotIndex, "*arena GAME OVER. No winner", 103 * .GameSound
     .Status = CHECK
    End If
   End Select
  End Select
 End If
nextbot:
 End With
Next
Exit Sub

FlyPaper:
AddTerminal BotIndex, "Error detected in tmrPeriodic(): " + Err.Description, 12
Resume Next
End Sub

Private Sub submnuFocusOnBot_Click(Index As Integer)
BotInFocus = CByte(Index)
UpdateTitleBar BotInFocus
UpdateTerminal BotInFocus
End Sub

Private Sub submnuSpawnLocal_Click(Index As Integer)
If Bots(Index).AutoConnect Or Bots(Index).Spawning Or Bots(Index).SpawnConnected Then
 UnloadBot CByte(Index), 0
Else
 If IP2Long(Bots(Index).LocalIP) = 0 Or Bots(Index).Name = "" Then
  MsgBox "Bot " & CStr(Index) & " doesn't have Name/IP. Edit Name/LocalIP entry for Bot" + CStr(Index) + " in your .INI"
 Else
  BotInFocus = CByte(Index)
  SpawnBot CByte(Index), Bots(Index).Type, Bots(Index).Name, Bots(Index).LocalIP, Bots(Index).LocalPort
 End If
End If
End Sub

Private Sub submnuSpawnRemote_Click(Index As Integer)
If Bots(Index).AutoConnect Or Bots(Index).Spawning Or Bots(Index).SpawnConnected Then
 UnloadBot CByte(Index), 0
Else
 If IP2Long(Bots(Index).RemoteIP) = 0 Or Bots(Index).Name = "" Then
  MsgBox "Bot " & CStr(Index) & " doesn't have Name/IP. Edit Name/RemoteIP entry for Bot" + CStr(Index) + " in your .INI"
 Else
  BotInFocus = CByte(Index)
  SpawnBot CByte(Index), Bots(Index).Type, Bots(Index).Name, Bots(Index).RemoteIP, Bots(Index).RemotePort
 End If
End If
End Sub
